//
// File:   rhino.cc
// Author: cteam053
//
// Created on October 27, 2012, 10:46 AM
//

#include <stdlib.h>
#include <cstdio>
#include <cmath>
#include <climits>
#include <iostream>

using namespace std;


int N;
char clr[5];
char val[5];
char pclr[2];
char pval[2];
int clrCnt[4];
bool cards[4][13];
bool comb[9];

int maxVal;
int maxPlayer[10];
int maxPlayerCnt;

int cardCnt[13];


int colorIdx(char c){
    switch(c){
        case 'c': return 0;
        case 'd': return 1;
        case 'h': return 2;
        case 's': return 3;
    }
}

int cardVal(char c){
    switch (c){
        case '2': return (0x1);
        case '3': return (0x2);
        case '4': return (0x3);
        case '5': return (0x4);
        case '6': return (0x5);
        case '7': return (0x6);
        case '8': return (0x7);
        case '9': return (0x8);
        case 'X': return (0x9);
        case 'J': return (0xA);
        case 'Q': return (0xB);
        case 'K': return (0xC);
        case 'A': return (0xD);
    }
}

int cardIdx(char c){
    switch (c){
        case '2': return (0);
        case '3': return (1);
        case '4': return (2);
        case '5': return (3);
        case '6': return (4);
        case '7': return (5);
        case '8': return (6);
        case '9': return (7);
        case 'X': return (8);
        case 'J': return (9);
        case 'Q': return (10);
        case 'K': return (11);
        case 'A': return (12);
    }
}

int cardVal(int a){
    switch (a){
        case 0: return (0x1);
        case 1: return (0x2);
        case 2: return (0x3);
        case 3: return (0x4);
        case 4: return (0x5);
        case 5: return (0x6);
        case 6: return (0x7);
        case 7: return (0x8);
        case 8: return (0x9);
        case 9: return (0xA);
        case 10: return (0xB);
        case 11: return (0xC);
        case 12: return (0xD);
    }
}

char space;

void clear(){
    for(int i = 0; i < 13 ; i++){
        
        
        
        
        
        
        
        
        
        
    }
}

int hash(){
    int hash;
    int mx = 0;
    for(int i = 0; i < 2; i++){
        cards[clrIdx(pclr[i])][cardIdx(pval[i])] = true;
        clrCnt[clrIdx(pclr[i])]++;
        cardCnt[cardIdx(pval[i])]++;
    }
    for(int i = 0; i < 13; i++){
        if(cardCnt[i] == 4){
            hash = cardVal(i) * pow(16, 7) + maxCard(i);
            mx = (mx < hash) ? hash : mx;
            comb[7] = true;
        }
        if(cardCnt[i] == 3){
            hash = cardVal(i) * pow(16, 3) + maxCard(i);
            mx = (mx < hash) ? hash : mx;
            comb[3] = true;
        }
        if(cardCnt[i] == 2){
            hash = cardVal(i) * pow(16, 1) + maxCard(i);
            mx = (mx < hash) ? hash : mx;
            comb[1] = true;
        }
        if(cardCnt[i] == 1){
            hash = maxCard(i);
            mx = (mx < hash) ? hash : mx;
            comb[0] = true;
        }
    }
    for(int i = 0; i < 4; i++){
        if(clrCnt[i] == 5){
            hash = maxColor(i);
        }
    }
    int old = -10;
    int cnt = 0;
    for(int i = 0; i < 13; i++){
        if(cardCnt[i] > 0){
            if(old + 1 = i){
                cnt++;
            } else {
                old = i;
                cnt = 1;
            }
            if(cnt == 5){
                hash = 
            }
        }
    }
}

int maxColor(int clr){
    int mx;
    for(int i = 0; i < 13; i++){
        if(cards[clr][i]){
            mx = i;
        }
    }
    return (mx);
}

int maxCard(int occ){
    int mx = -1;
    for(int i = 0; i < 13; i++){
        if(i == occ){
            continue;
        }
        if(cardCnt[i] > 0){
            mx = (mx < i) ? i : mx;
        }
    }
    return (mx);
}

int main(int argc, char** argv) {
    
    while(scanf("%d", &N) == 1){
        while(getchar() != '\n');
        if(N <= 0){
            break;
        }
        maxPlayerCnt = 0;
        maxVal = -1;
        for(int i = 0; i < 4; i++){
            clrCnt[i] = 0;
            for(int j = 0; j < 13; j++){
                cards[i][j] = false;
                cardCnt[j] = 0;
            }
        }
        for(int i = 0; i < 9; i++){
            comb[i] = false;
        }
        scanf("%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",
                &val[0], &clr[0], &space, &val[1], &clr[1], &space, &val[2], &clr[2], &space, &val[3], &clr[3], &space, &val[4], &clr[4], &space);
        
        for(int i = 0; i < 5; i++){
            cards[colorIdx(clr[i])][cardIdx(val[i])] = true;
            cardCnt[cardIdx(val[i])]++;
            clrCnt[clrIdx(clr[i])]++;
        }
        for(int i = 0; i < N; i++){
            scanf("%c%c%c%c%c", &pval[0], &pclr[0], &space, &pval[1], &pclr[1]);
            int hash = hash();
            if(maxVal < hash){
                maxVal = hash;
                maxPlayerCnt = 0;
                maxPlayer[maxPlayerCnt++] = i;
            } else if(maxVal == hash){
                maxPlayer[maxPlayerCnt++] = i;
            }
            clear();
        }
        for(int i = 0; i < maxPlayerCnt; i++){
            if(i + 1 == maxPlayerCnt){
                printf("%d\n", maxPlayer[i]);
            }else {
                printf("%d ", maxPlayer[i]);
            }
        }
        
    }
    
    return (0);
}

